import { api } from 'electron-util'
import Store from 'electron-store'
import { join } from 'path'
import { hostname } from 'os'

api.app.name = 'svws.report'

console.log('Config laden …')

export interface StoreType {
  encryptionKey: string;
  windowBounds: {main:{width: number; height:number}};
  reports:string;
  pdf:string;
  userData:string;
  privateDaten:object;
  folderStates:object;
  debug:boolean;
  certificate_errors:boolean;
  cache:boolean;
  write:boolean;
  source_maps:boolean;
}


const configFile = new Store<StoreType>({
  configFileMode: 0o666,
  defaults: {
    encryptionKey: hostname(),
    windowBounds: {
      main: { width: 1800, height: 800 }
    },
    reports: join(api.app.getPath("documents"), api.app.name, "reports"),
    pdf: join(api.app.getPath("documents"), api.app.name, "pdf"),
    userData: join(api.app.getPath("userData")),
    privateDaten: {},
    folderStates: {},
    debug: true,
    certificate_errors: false,
    cache: true,
    write: false,
    source_maps: true
  },
});
export default configFile
