export const focus = (node: HTMLInputElement):void => node.focus();
export const group_by = (array:Array<object>, key:string):object => {
  return array.reduce((result, currentValue) => {
    (result[currentValue[key]] = result[currentValue[key]] || []).push(
      currentValue
    );
    return result;
  }, {});
};
export const datum = (t: string):string => {
  // gibt ein Datum im deutschen Format zurück
  try {
    return new Date(t).toLocaleDateString("de", {
      day: "2-digit",
      month: "2-digit",
      year: "numeric",
      timeZone: "Europe/Berlin"
    });
  } catch (e) {
    console.log(e);
    return;
  }
};
export const alter = (datum: Date):number => {
  try {
    const d = new Date();
    const g = new Date(datum);
    const alter =
      d.getFullYear() -
      g.getFullYear() -
      (d.getMonth() > g.getMonth() ||
      (d.getMonth() == g.getMonth() && d.getDay() >= g.getDay())
        ? 0
        : 1);
    return alter;
  } catch (e) {
    console.log(e);
    return;
  }
};
