import { ipcRenderer } from 'electron'
import type { SvelteComponent } from 'svelte';
// import { create_proxy } from './api_proxy';
import { ApiServer } from '@svws-nrw/svws-ts-lib'
// import { ApiServer} from '../../SVWS-Server/svws-ts-lib/src/main/ts/index'

const Mark = require('mark.js')
const requireFromString = require('require-from-string');

let svelte: SvelteComponent,
  props,
  Component,
  mark,
  compiled_module: { code: string },
  api_config,
  proxy,
  api

function runMark() {
  mark = new Mark(document.querySelector('body'))
  mark.mark(['undefined', '01.01.1970', 'null'])
}
ipcRenderer.on('props', (event, data) => {
  props = data.svelteProps
  api_config = api_config || data.api_config
  api = new ApiServer(
    api_config.server,
    api_config.username,
    api_config.password
  );
  props.api = api //proxy || create_proxy(api_config)
  // const config = client.createConfiguration({
  //   authMethods: { basicAuth: { username: api_config.username, password: api_config.password } },
  //   baseServer: new client.ServerConfiguration<{}>(api_config.server, {}),
  // })
  // const config = {username: api_config.username, password: api_config.password}
  // props.raw = new client.ServerApi(config)
  svelte?.$set(props)
  compiled_module = data.compiled_module
})
ipcRenderer.on('set_dokument', () => {
  if (svelte) svelte.$destroy()
  try {
    Component = requireFromString(compiled_module.code);
    svelte = new Component({ target: document.querySelector('svelte'), props })
    console.log('Svelte-Dokument erfolgreich geladen.')
    ipcRenderer.sendToHost('dokument_options', {
      kommentar: svelte.kommentar,
      pdf_name: svelte.pdf_name,
      generic_pdf: svelte.generic_pdf
    })
  } catch (error) {
    // const { serializeError } = require('serialize-error')
    console.log('Das Svelte-Dokument konnte nicht geladen werden:', error)
    // ipcRenderer.sendToHost('error_message', serializeError(error))
  }
  runMark()
})

ipcRenderer.on('open_devtools', (event, data) => {
  globalThis.daten = data
  console.group('Report-Daten')
  console.log('Die für Reports zur Verfügung stehenden Daten sind unter `daten` abgelegt:')
  console.log(globalThis.daten)
  console.groupEnd()
})
ipcRenderer.on('set_edit', (event, edit) => {
  document.querySelector('#content').setAttribute('contenteditable', edit)
})
ipcRenderer.on('set_mark', (event, state) => {
  state ? runMark() : mark.unmark()
})
