import { type Writable, writable } from "svelte/store";
import { ipcRenderer } from 'electron';
import type { SvelteComponent } from "svelte";
import type { SchuelerStammdaten } from '@svws-nrw/svws-ts-lib'
import type Dokument from './components/Dokument.svelte'
import type { StoreType } from './configstore'
import type { Path } from "typescript";

export let configData: Writable<StoreType>
const store: Promise<StoreType> = ipcRenderer.invoke("get_store").then((res: StoreType) => {
  configData = writable(res);
  configData.subscribe((value) => {
    ipcRenderer.invoke("set_store", value);
  });
  return res
});
export const api_config: Writable<any> = writable(undefined)
export const raw_api_config: Writable<Record<'username'| 'password' | 'schema' | 'server', string>> = writable(undefined)
export const schema: Writable<string> = writable(undefined);
export const component: Writable<typeof SvelteComponent|undefined> = writable(undefined);
export const webview: Writable<Electron.WebviewTag> = writable(undefined);
export const dokument: Writable<Path> = writable(undefined);
export const schueler: Writable<SchuelerStammdaten[]> = writable(undefined);
export const selected: Writable<SchuelerStammdaten[]> = writable(undefined)
export const dokument_component: Writable<Dokument> = writable(undefined);
export const error: Writable<{ message: string; stack: object }|undefined> = writable(undefined);
export const schueler_sortiert: Writable<[string | undefined, SchuelerStammdaten[]][]> = writable(undefined)
export const set_mark: Writable<boolean> = writable(true);
export const set_edit: Writable<boolean> = writable(false);
export const warten: Writable<boolean> = writable(false);
export const kommentar: Writable<string> = writable(undefined);
export const abschnitt: Writable<number> = writable(1);
export const jahr: Writable<number> = writable(1900);
export const repo: Writable<string> = writable("");
export const pdf_name: Writable<string> = writable("");
export const generic_pdf: Writable<string> = writable("");
